local CPFrame = CreateFrame("Frame", "PlayerComboFrame", PlayerFrame)
local currentCP, lastCP, currentAnti, lastAnti = 0, 0, 0, 0
local CPs = {}
local Anti = {}
CPFrame:RegisterEvent("UNIT_POWER")
CPFrame:RegisterEvent("ADDON_LOADED", addonName)
CPFrame:RegisterEvent("PLAYER_SPECIALIZATION_CHANGED")
CPFrame:RegisterEvent("UNIT_AURA")
CPFrame:RegisterEvent("UNIT_ENTERING_VEHICLE")
CPFrame:RegisterEvent("UNIT_EXITED_VEHICLE")
CPFrame:RegisterEvent("PLAYER_ENTERING_WORLD")

function CPFrame:OnEvent(event, ...)
	self[event](self, ...)
end
CPFrame:SetScript("OnEvent", CPFrame.OnEvent)

function CPFrame:PLAYER_ENTERING_WORLD()
	if CPs[1] then
		CPFrame:UNIT_POWER()
	end
	local _, class, _ = UnitClass('player')
	local spec = GetSpecialization()
	if class == "DRUID" and spec == 2 and CPs[1] == nil then
		CPFrame:LoadFrame()
	end
end

function CPFrame:ADDON_LOADED(addonName)
	if addonName == "PlayerCP" then
		CPFrame:LoadFrame()
	elseif addonName == "ShadowedUnitFrames" or addonName == "ElvUI" or addonName == "XPerl_Player" then
		CPFrame:SetParent("UIParent")
		--[[local OriginalOnInitialize = ShadowUF.OnInitialize

		ShadowUF.OnInitialize = function(Self)
			OriginalOnInitialize(Self)

			CPFrame:SetParent(UIParent)
		end]]
	end
end

function CPFrame:LoadFrame()
	local _, class, _ = UnitClass('player')
	local spec = GetSpecialization()
	local tempY = 53
	if class == "DRUID" then
		tempY = 35
	end
	if class == "ROGUE" or class == "DRUID" and spec == 2 then
	-- Hide default Blizzard frame
		ComboFrame:UnregisterAllEvents()
		ComboFrame:Hide()
		CPFrame:SetFrameStrata("LOW")
		CPFrame:SetFrameLevel(1)
		CPFrame:SetSize(256,64)
		-- A ClearAllPoints() is not needed here, otherwise it would ruin people's drag-movement locations.
		CPFrame:SetPoint("TOP", PlayerFrame, "BOTTOM", 45, tempY)
		CPFrame:SetScale(.9)
		CPFrame.tex = CPFrame:CreateTexture(nil, "LOW", nil, 0)
		CPFrame.tex:SetAllPoints()
		CPFrame.tex:SetTexture("Interface\\AddOns\\PlayerCP\\Media\\ComboFrame.tga")
		local x = 69.7
		local frameName = nil
		for i = 1,5 do
			local frameName = "PlayerComboPoint"..i
			local frame = CreateFrame("Frame", frameName, CPFrame)
			frame:SetPoint("LEFT", CPFrame, "LEFT", x, 1)
			x = x + 27
			frame:SetSize(20,20)
			frame.tex = frame:CreateTexture(nil, "LOW", nil, 0)
			frame:SetFrameLevel(6)
			frame.tex:SetAllPoints()
			frame.isShown = false
			--[[if class == "ROGUE" and spec == 1 then
				frame.tex:SetTexture("Interface\\AddOns\\PlayerCP\\Media\\ComboPointAssass.tga")
			elseif class == "ROGUE" and spec == 2 then]]
				frame.tex:SetTexture("Interface\\AddOns\\PlayerCP\\Media\\ComboPointCombat.tga")
			--[[elseif class == "ROGUE" and spec == 3 then
				frame.tex:SetTexture("Interface\\AddOns\\PlayerCP\\Media\\ComboPointSub.tga")
			elseif class == "DRUID" then
				frame.tex:SetTexture("Interface\\AddOns\\PlayerCP\\Media\\ComboPointDurid.tga")
			end]]
			frame:Hide()
			CPs[i] = frame
		end
	end
	
	if class == "ROGUE" then -- Yeah I could've put this up there. I'm tired though; it's 3:00 AM.
		for i = 1, 5 do
			local frameName = "Anticipation "..i
			local frame = CreateFrame("Frame", frameName, CPFrame)
			frame:SetPoint("CENTER", CPs[i], "CENTER", 0, 0)
			frame:SetSize(45,45)
			frame.tex = frame:CreateTexture(nil, "LOW", nil, 0)
			frame:SetFrameLevel(4)
			frame.tex:SetAllPoints()
			frame.tex:SetTexture("Interface\\AddOns\\PlayerCP\\Media\\Anticipation.tga")
			frame:Hide()
			Anti[i] = frame
		end
	end
	
	CPFrame:SetMovable(true)
	CPFrame:EnableMouse(true)
	CPFrame:RegisterForDrag("LeftButton")
	CPFrame:SetScript("OnDragStart", function()
		if IsAltKeyDown() == true then
			CPFrame:StartMoving()
		end
	end)
	CPFrame:SetScript("OnDragStop", CPFrame.StopMovingOrSizing)
	CPFrame:SetScript("OnMouseDown", function(self, button)
		if button == "RightButton" and IsAltKeyDown() == true and not self.isMoving then
			self:ClearAllPoints()
			self:SetPoint("TOP", PlayerFrame, "BOTTOM", 45, tempY)
			if IsAddOnLoaded("ShadowedUnitFrames") or IsAddOnLoaded("ElvUI") then
				self:SetParent(UIParent)
			end
		end
	end)
end

function CPFrame:UNIT_ENTERING_VEHICLE()
	if UnitInVehicle("player") then
	if CPs[1] then
		CPFrame:Hide()
		ComboFrame:RegisterEvent("PLAYER_TARGET_CHANGED")
		ComboFrame:RegisterEvent("UNIT_COMBO_POINTS")
	end
	end
end

function CPFrame:UNIT_EXITED_VEHICLE()
	if UnitInVehicle("player") then return end
	if CPs[1] then
		CPFrame:Show()
		ComboFrame:UnregisterAllEvents()
		ComboFrame:Hide()
	end
end

local COMBOFRAME_FADE_IN = 0.3
local COMBOFRAME_FADE_OUT = 0.1
function CPFrame:UNIT_POWER()
	currentCP = UnitPower("player", 4)
	InCombat = UnitAffectingCombat("player")
	if currentCP > lastCP then -- Generator
		for i = 1, currentCP do
			if CPs[i].isShown == false then
				CPs[i].isShown = true
				UIFrameFadeIn(CPs[i], COMBOFRAME_FADE_IN)
			end
		end
	else -- Finisher/Decay/Premed time-out
		for i = currentCP + 1, lastCP do
			CPs[i].isShown = false
			UIFrameFadeOut(CPs[i], COMBOFRAME_FADE_OUT)
		end
	end
	lastCP = currentCP
	ComboFrame:Hide() -- For some reason the old CP frame's still showing up...
end

function CPFrame:PLAYER_SPECIALIZATION_CHANGED()
	for i = 1, 5 do UIFrameFadeOut(CPs[i], COMBOFRAME_FADE_OUT) end
	local _, class, _ = UnitClass('player')
	local currentSpec = GetSpecialization()
	if class == "DRUID" and currentSpec == 2 then
		if CPFrame == nil then
			CPFrame:LoadFrame()
		else
			CPFrame:Show()
		end
	elseif class == "DRUID" then
		if CPFrame ~= nil then
			CPFrame:Hide()
		end
	end
	--[[if class == "ROGUE" and currentSpec == 1 then
		for i=1,5 do CPs[i].tex:SetTexture("Interface\\AddOns\\PlayerCP\\Media\\ComboPointAssass.tga") end
	elseif class == "ROGUE" and currentSpec == 3 then
		for i=1,5 do CPs[i].tex:SetTexture("Interface\\AddOns\\PlayerCP\\Media\\ComboPointSub.tga") end
	elseif class == "ROGUE" then -- Catch all for un-specc'd and Combat rogues. Can't be else, or you'll get an error on non-rogue/ferals.
		for i=1,5 do CPs[i].tex:SetTexture("Interface\\AddOns\\PlayerCP\\Media\\ComboPointCombat.tga") end
	end]]
end

function CPFrame:UNIT_AURA(unit) -- Anticipation
	local _, class, _ = UnitClass('player')
	if unit == "player" and class == "ROGUE" then
		_, _, _, currentAnti = UnitAura(unit, "Anticipation", nil, "PLAYER|HELPFUL")
		if currentAnti == nil then
			currentAnti = 0
		end
		if currentAnti > 0 then
			numATtoAnimate = currentAnti - lastAnti
			while numATtoAnimate > 0 do
				lastAnti = lastAnti + 1
				UIFrameFadeIn(Anti[lastAnti], COMBOFRAME_FADE_IN)
				numATtoAnimate = numATtoAnimate - 1
			end
		else
			for i = 1, lastAnti do UIFrameFadeOut(Anti[i], COMBOFRAME_FADE_OUT) end
		end
		lastAnti = currentAnti
	end
end


--[[	All hail based Lore. This will remain as a memorial to the hours, and hours, and HOURS of work it took.

	This is for (attempting) to keep track of combo point events when nothing is targeted;
		First: Premeditation problems
		Second: Seal Fate/HaT/Ruth procs as a target dies, or with no target.
			(Note: Target dummy testing gets weird with this if you're out of combat. Not sure how to fix.)
		Third: Finisher use as a target dies, or with no target.
		Fourth: Reset CP's on death.
	]]
--[[function CPFrame:COMBAT_LOG_EVENT_UNFILTERED(timeStamp, eventType, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellID, spellName, spellSchool, auraType)
	local TarCheck = GetUnitName("target")
	if eventType == "SPELL_CAST_SUCCESS" and spellID == 14183 and GetUnitName("player") == sourceName then
		premed == true
		local newCP = lastCP + 2
		if UnitAffectingCombat("player") == false then newCP = newCP + 1 end
		if newCP > 5 then
			newCP = 5
		end
		for i = lastCP, newCP do
			UIFrameFadeIn(CPs[lastCP], COMBOFRAME_FADE_IN)
			lastCP = lastCP + 1
		end
		lastCP = newCP
		local premedTimer = C_Timer.NewTimer(18, function()
			if premed == true then
				for i = lastCP - 2, lastCP do
					UIFrameFadeOut(CPs[i], COMBOFRAME_FADE_OUT)
				end
			end
		end)
 	elseif (spellID == 51699 or spellID == 14161 or spellID == 14189) and GetUnitName("player") == sourceName and TarCheck == nil then
		local newCP = lastCP + 1
		if UnitAffectingCombat("player") == false then newCP = newCP + 1 end
		if newCP > 5 then
			newCP = 5
		end
		for i = lastCP, newCP do
			UIFrameFadeIn(CPs[lastCP], COMBOFRAME_FADE_IN)
			lastCP = lastCP + 1
		end
		lastCP = newCP
	elseif eventType == "SPELL_CAST_SUCCESS" or eventType == "SPELL_AURA_APPLIED" or eventType == "SPELL_AURA_REFRESH" then
		if GetUnitName("player") == sourceName then
			if (spellID == 5171 or spellID ==73651 or spellID == 52610 or spellID == 408 or spellID == 2098 or spellID == 152150 or spellID == 26679 or spellID == 1943 or spellID == 22568 or spellID == 1079 or spellID == 121411) and TarCheck == nil then
				for i = 1, lastCP do UIFrameFadeOut(CPs[i], COMBOFRAME_FADE_OUT) end
				currentCP, lastCP = 0, 0
				if premed == true then
					premed = false
				end
			end
		end
	elseif CPs[1] and eventType == "UNIT_DIED" and GetUnitName("player") == destName then
		for i = 1,lastCP do
			CPs[i]:Hide()
		end
		currentCP, lastCP = 0, 0
	end
end]]